<?
# Module: DB
# hopp-dbfunctions-pg.inc - Database driver for Postgres
# Derechos Reservados (c) 2000-2002 Sandino Araico Snchez
# Derechos Reservados (c) 2002 Presidencia de la Repblica
# Copyright (c) 2000-2002 Sandino Araico Snchez All rights reserved

/*
 * --COMIENZA LICENCIA EN ESPAOL MEXICANO-------------------------------------
 * Por ste medio se otroga permiso, libre de cargo, a cualquier persona que
 * obtenga una copia de este software y archivos de documentacin asociados
 * (el "Software"), a utilizar el Software sin restriccin, incluyendo sin 
 * limitacin los derechos de usar, copiar, modificar, unir, publicar, 
 * distribuir y/o vender copias de el Software, y permitir lo mismo a personas 
 * a quienes les sea entregado el software, siempre y cuando los avisos de 
 * Derechos reservados y Copyright que aparecen arriba y ste permiso (en 
 * espaol y en ingls) aparezcan en todas las copias de el Software y que 
 * tanto los avisos de Derechos reservados y Copyright que aparecen arriba como
 * ste permiso (en espaol y en ingls) aparezcan en la documentacin de
 * soporte.
 *
 * ESTE SOFTWARE SE PROVEE "TAL CUAL", SIN NINGUNA GARANTA DE NINGN TIPO,
 * EXPRESA O IMPLCITA, INCLUYENDO PERO NO LIMITNDOSE A LAS GARANTAS DE
 * MERCANTIBILIDAD, ADECUACIN PARA UN PROPSITO EN PARTICULAR Y NO 
 * INFRACCIN DE LOS DERECHOS DE TERCERAS PARTES. EN NINGN MOMENTO EL O LOS 
 * TITULARES DE LOS DERECHOS DE AUTOR Y COPYRIGHT INCLUIDOS EN ESTE AVISO SERN
 * RESPONSABLES POR CUALQUIER RECLAMACIN O POR CUALQUIER DAO ESPECIAL,
 * INDIRECTO O CONSECUENTE, O CUALQUIER DAO QUE RESULTE DE LA PRDIDA DE USO,
 * DATOS O GANANCIAS, YA SEA EN UNA ACCIN DE CONTRATO, NEGLIGENCIA U OTRA 
 * ACCIN TORTUORIA, RESULTANTE DE O EN CONEXIN CON EL USO O DESEMPEO DE
 * ESTE SOFTWARE.
 *
 * Excepto que se incluya en ste aviso, no se debe usar el nombre de ningn 
 * titular de Derechos de autor o Copyright en publicidad o de otra manera 
 * psra promover la venta, uso u otros tratos en este Software sin previa 
 * autorizacin por escrito del titular de Derechos de autor o Copyright.
 * --TERMINA LICENCIA----------------------------------------------------------
 *
 * --BEGIN LICENSE IN US ENGLISH-----------------------------------------------
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, and/or sell copies of the Software, and to permit persons
 * to whom the Software is furnished to do so, provided that the above
 * copyright and "Derechos reservados" notices and this permission notice  
 * (in spanish and english) appear in all copies of the Software and that both 
 * the above copyright and "Derechos reservados" notices and this permission 
 * notice (in spanish and english) appear in supporting documentation.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT
 * OF THIRD PARTY RIGHTS. IN NO EVENT SHALL THE COPYRIGHT AND "DERECHOS DE 
 * AUTOR" HOLDER OR HOLDERS INCLUDED IN THIS NOTICE BE LIABLE FOR ANY CLAIM, OR 
 * ANY SPECIAL INDIRECT OR CONSEQUENTIAL DAMAGES, OR ANY DAMAGES WHATSOEVER 
 * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF 
 * CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN 
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 * 
 * Except as contained in this notice, the name of a copyright or "Derechos de
 * autor" holder shall not be used in advertising or otherwise to promote the
 * sale, use or other dealings in this Software without prior written 
 * authorization of the copyright or "Derechos de autor" holder.
 * --END LICENSE---------------------------------------------------------------
 */
 
# Changelog: 
# 2000-09-08 Sandino Araico Snchez
# 2002-02-06 Sandino Araico Snchez - transaction functions now return a value

if(!defined("__HOPP_DBFUNCTIONS"))
{
define("__HOPP_DBFUNCTIONS",1);
#----------------------------------------------------------------------------
#----------------------------------------------------------------------------

function hopp_db_config()
{
	if(file_exists("db-params.inc.php"))
		include "db-params.inc.php";
	else if (file_exists("db/postgres/db-params.inc.php"))	
		include __HOPP_INCLUDE_PATH."db/postgres/db-params.inc.php";
}

function hopp_db_connect()
{
	if(!defined("__HOPP_DBPARAMS_PG"))
	hopp_db_config();
	s_log("__HOPP_DBPARAMS_PG: ".__HOPP_DBPARAMS_PG);
	s_log("__HOPP_DB_NAME: ".__HOPP_DB_NAME);
	if(defined("__HOPP_DBPARAMS_PG"))
	{
		if(defined("__HOPP_DB_CONNECT_PERSISTENT"))
			return pg_pconnect(__HOPP_DB_HOST, __HOPP_DB_PORT, __HOPP_DB_OPTIONS, __HOPP_DB_TTY, __HOPP_DB_NAME);
		else	
			return pg_connect(__HOPP_DB_HOST, __HOPP_DB_PORT, __HOPP_DB_OPTIONS, __HOPP_DB_TTY, __HOPP_DB_NAME);
	}	
}

function hopp_db_release($id)
{
	pg_close ($id);
}

function hopp_db_connected($id)
{
	return ($id?$id:hopp_db_connect());
}

function hopp_db_start_transaction($id)
{
	return hopp_db_exec($id, "begin");
}

function hopp_db_end_transaction($id)
{
	return hopp_db_exec($id, "commit");
}

function hopp_db_rollback_transaction($id)
{
	return hopp_db_exec($id, "rollback");
}

function hopp_db_exec($id, $sql)
{
	return pg_exec($id, $sql);
}

function hopp_db_get_sequential_id($id, $seq_name)
{
	return hopp_db_get_sequential_next_id($id, $seq_name);
}

function hopp_db_get_sequential_next_id($id, $seq_name)
{
	$sql="select nextval('$seq_name')";
	return hopp_db_get_single_field_result($id, $sql);
}

function hopp_db_get_sequential_curr_id($id, $seq_name)
{
	$sql="select currval('$seq_name')";
	return hopp_db_get_single_field_result($id, $sql);
}

function hopp_db_get_single_field_result($id, $sql)
{
	$cur=hopp_db_exec($id, $sql);
	if(pg_numrows($cur))
		return pg_result($cur,0,0);
}

function hopp_db_get_single_field_result_decoded($id, $sql)
{
	return rawurldecode(hopp_db_get_single_field_result($id, $sql));
}

function hopp_db_get_n_row_array_result($cur, $row)
{
	return pg_fetch_array ($cur, $row, PGSQL_ASSOC);
}

function hopp_db_get_single_row_array_result($id, $sql)
{
	$cur=hopp_db_exec($id, $sql);
	if(pg_numrows($cur))
		return hopp_db_get_n_row_array_result($cur, 0);
}

function hopp_db_get_single_row_array_result_decoded($id, $sql)
{
	$array_orig=hopp_db_get_single_row_array_result($id, $sql);
	return hopp_db_decode_array($array_orig);
}

function hopp_db_decode_array($array_orig)
{
	if(!is_array($array_orig))
		return;
	while(list($key, $value)=each($array_orig))
		$array[$key]=rawurldecode($value);
	return $array;	
}

function hopp_db_get_multi_row_array_result($id, $sql)
{
	$cur=hopp_db_exec($id, $sql);
	$numrows=pg_numrows($cur);
	for($i=0;$i<$numrows;$i++)
	{
		$result_array[$i]=hopp_db_get_n_row_array_result($cur, $i);
	}
	return $result_array;
}

function hopp_db_get_multi_row_array_result_decoded($id, $sql)
{
	$array_orig=hopp_db_get_multi_row_array_result($id, $sql);
	return hopp_db_decode_multi_row_array($array_orig);
}

function hopp_db_decode_multi_row_array($array_orig)
{
	if(!is_array($array_orig))
		return;
	while(list($key, $value)=each($array_orig))
		$array[$key]=hopp_db_decode_array($value);
	return $array;	
}

#----------------------------------------------------------------------------
} // __HOPP_DBFUNCTIONS
?>
